#guard fn_damageSystem

library FNWEDamageSystem{

    trigger fn_DamageEventTrigger = null

    private trigger array DamageEventQueue
    private integer DamageEventNumber = 0
	
    private trigger MoveItemEventTrigger = null
    private trigger array MoveItemEventQueue
    private integer MoveItemEventNumber = 0

nothing FNWEAnyUnitDamagedTriggerAction(){
    integer i = 0
    
    loop{
        exitwhen i >= DamageEventNumber
        if DamageEventQueue[i] != null && IsTriggerEnabled(DamageEventQueue[i]) && TriggerEvaluate(DamageEventQueue[i]){
            TriggerExecute(DamageEventQueue[i])
        }
        i++
    }    
}

boolean FNWEAnyUnitDamagedFilter(){
    if GetUnitAbilityLevel(GetFilterUnit(), 'Aloc') <= 0{
        TriggerRegisterUnitEvent(fn_DamageEventTrigger, GetFilterUnit(), EVENT_UNIT_DAMAGED)
    }
    return false
}

nothing FNWEAnyUnitDamagedEnumUnit(){
    trigger t = CreateTrigger()
    region  r = CreateRegion()
    group   g = CreateGroup()

    RegionAddRect(r, GetWorldBounds())
    TriggerRegisterEnterRegion(t, r, Condition(function FNWEAnyUnitDamagedFilter))
    GroupEnumUnitsInRect(g, GetWorldBounds(), Condition(function FNWEAnyUnitDamagedFilter))

    DestroyGroup(g)
    r = null
    t = null
    g = null
}
	
nothing FNWETriggerRegisterAnyUnitDamaged(trigger trg){
    if trg == null{
        return
    }
        
    if DamageEventNumber == 0{
        fn_DamageEventTrigger = CreateTrigger()
        TriggerAddAction(fn_DamageEventTrigger, function FNWEAnyUnitDamagedTriggerAction) 
        FNWEAnyUnitDamagedEnumUnit()
    }   
    
    DamageEventQueue[DamageEventNumber] = trg
    DamageEventNumber++
}

}